      Program PeakFit
      Include 'PeakFit.prm'
      Character*80 fname
      Character*80 Title, PrgNam, Method, IntFil
      Real QRange
      Real CalcX0, CalcX1, OptX0, OptX1
      Real Back(MBack)
      Integer idBack(MBack), nPeak, nCycle, nBack
      Real Dump
      Real Angle(MPeak), Height(MPeak), GFrac(MPeak), Gfwhm(MPeak)
      Real Lfwhm(MPeak), rfwhm(MPeak)
      Real Aniso(MPeak), CGau(MPeak), CLor(MPeak)
      Integer idAng(MPeak), idHei(MPeak), idGFra(MPeak), idGfwh(MPeak)
      Integer idLfwh(MPeak)
      Integer idrfwh(MPeak), idAnis(MPeak)
      Real XOrg(MOData), YOrg(MOData), XVal(MData), YVal(MData)
      Integer nOData, nData
      Integer nMtx
      Integer IdxPek(MMtx), IdxKnd(MMtx)
      Real YCal(MData), YErr(MData)
      Real BG(MData)
      Real*8 AMtx(MMtx, MMtx), BMtx(MMtx)
      Real OAngle(MPeak), OHeigh(MPeak), OGFrac(MPeak), OGfwhm(MPeak)
      Real OLfwhm(MPeak), Orfwhm(MPeak), OAniso(MPeak), OBack(MBack)
      Real PAngle(MPeak), PCGau(MPeak), PCLor(MPeak), PGfwhm(MPeak)
      Real Prfwhm(MPeak), PAniso(MPeak), PBack(MBack)
      Real DifEPS, Sigma, PSigma
      Real ramda1, ramda2, IRatio
      
      Integer*4 iStat
      Integer IsConv
      
      If(nArgs() .le. 1) Then
        Write(6, '(a)') ' ******  Fatal Error ******'
        Write(11, '(a)') ' ******  Fatal Error ******'
        Write(6, '(a)') '  Usage: PeakFit file_name'
        Write(11, '(a)') '  Usage: PeakFit file_name'
        Stop 9999
      EndIf
      
      Open(11, file='out.txt', status='UNKNOWN', form='FORMATTED')
      Call GetArg(1, fname, iStat)
      Call RdFile(4, fname, IntFil, Title, PrgNam, Method, nCycle,
     1      Dump, QRange, ramda1, ramda2, IRange,
     2      CalcX0, CalcX1, OptX0, OptX1, nBack, Back, idBack,
     3      nPeak, nOData, Angle, Height, GFrac, Gfwhm, Lfwhm,
     4      rfwhm, Aniso, XOrg, YOrg, idAng, idHei, idGFra, idGfwh,
     5      idLfwh, idrfwh, idAnis, DifEPS)
      Call SvOld(nPeak, Angle, OAngle, Height, OHeigh, GFrac, OGFrac,
     1           Gfwhm, OGfwhm, Lfwhm, OLfwhm, rfwhm, Orfwhm, Aniso,
     2           OAniso, nBack, Back, OBack)
      Call CnvDat(nOData, XOrg, YOrg, nData, XVal, YVal,
     1            CalcX0, CalcX1, nPeak, Gfwhm,
     2            CGau, CLor, Height, GFrac)
      Call MkIdx(nPeak, Angle, idBack, idAng, idHei, idGFra, idGfwh,
     1            idrfwh, idAnis, OptX0, OptX1, nMtx, IdxPek, IdxKnd)
      Call BasPrf(nData, XVal, YVal, YCal, BG, YErr, nPeak,
     1       CGau, CLor, Angle, Aniso, Gfwhm, rfwhm, nBack, Back,
     2       QRange, Sigma, PSigma)
c      Call SvErr(10, 'error.dat', Title, nData, XVal, YErr)
c      Call SvPat(9, 'first.pat', Title, nData, XVal, YVal, YCal,
c     1         BG)
      Do 10 ic=1, nCycle
        Write(6, '(a, i3, 2g14.6)') ' Start cycle ', ic, Sigma, PSigma
        Write(11, '(a, i3, 2g14.6)') ' Start cycle ', ic, Sigma, PSigma
        Call Diff(nMtx, AMtx, BMtx, IdxPek, IdxKnd,
     1            nData, XVal, YErr, nPeak, CGau, CLor,
     2            Angle, Aniso, Gfwhm, rfwhm,
     3            QRange, nBack)
c        Call SvMtx(11, 'matrix.dat', nMtx, AMtx, BMtx)
        Call OldPrm(nPeak, Angle, Aniso, CGau, CLor,
     1              Gfwhm, rfwhm, PAngle, PAniso, PCGau, PCLor,
     2              PGfwhm, Prfwhm, nBack, Back, PBack)
        Call Marq(nMtx, AMtx, BMtx, Dump)
        Call NewPrm(nMtx, IdxPek, IdxKnd, BMtx, Angle, Aniso,
     1              CGau, CLor, Gfwhm, rfwhm, Back, DifEPS, IsConv)
        If(IsConv .eq. 1) Then
          Write(6, '(a)') ' ******  Converged  *****'
          Write(11, '(a)') ' ******  Converged  *****'
          GoTo 20
        EndIf  
        Call BasPrf(nData, XVal, YVal, YCal, BG, YErr, nPeak,
     1         CGau, CLor, Angle, Aniso, Gfwhm, rfwhm, nBack, Back,
     2         QRange, Sigma, PSigma)
   10 Continue
   20 Continue
c      Call SvPat(19, 'final.pat', Title, nData, XVal, YVal, YCal,
c     1         BG)
      Call InvDat(nPeak, Gfwhm, Lfwhm, rfwhm, CGau, CLor, GFrac, Height,
     1            Aniso)
      Call SvFile(1, 'new.pfc', IntFil, Title, PrgNam, Method, nCycle,
     1      Dump, QRange, ramda1, ramda2, IRatio,
     2      CalcX0, CalcX1, OptX0, OptX1, Back, idBack,
     3      nPeak, nOData, Angle, Height, GFrac, Gfwhm, Lfwhm,
     4      rfwhm, Aniso, XOrg, YOrg, idAng, idHei, idGFra, idGfwh,
     5      idLfwh, idrfwh, idAnis, OAngle, OHeigh, OGFrac, OGfwhm,
     6      OLfwhm, Orfwhm, OAniso, OBack, DifEPS)
      Call PArea(nPeak, Angle, CGau, CLor, Gfwhm, Lfwhm)
      Close(11)
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine PArea(nPeak, Angle, CGau, CLor, Gfwhm, Lfwhm)
      Include 'PeakFit.prm'
      Integer nPeak
      Real CGau(*), CLor(*), Gfwhm(*), Lfwhm(*), Angle(*)
      
      Integer i
      Real CTot, fwhm, stot
      Real s(MPeak), coeG, coeL, smax
c        coeG = sqrt(pi/4.0/log2)
c        coeL = pi/2.0
      Data coeG, coeL/1.064467019, 1.570796327/

      Write(6, '(/a,a)')
     1     ' *** Peak area: #   2Q        C    ',
     2     '    fwhm      I      I(rel)     I(%)***'
      Write(11, '(/a,a)')
     1     ' *** Peak area: #   2Q        C    ',
     2     '    fwhm      I      I(rel)     I(%)***'
      smax = 0.0
      stot = 0.0
      Do 10 i=1, nPeak
        s(i) = CGau(i)*coeG*Gfwhm(i) + CLor(i)*coeL*Lfwhm(i)
        if(smax .lt. s(i)) smax = s(i)
        stot = stot + s(i)
   10 Continue
      Do 20 i=1, nPeak
        CTot = CGau(i)+CLor(i)
        fwhm = CGau(i)/CTot*Gfwhm(i) + CLor(i)/CTot*Lfwhm(i)
        Write(6, '(i3, f8.3,g16.6, f8.3, g14.6, f10.0, f10.4)')
     1    i, Angle(i), CTot, fwhm, s(i), s(i)/smax*10000, s(i)/stot*100.0
        Write(11, '(i3, f8.3,g16.6, f8.3, g14.6, f10.0, f10.4)')
     1    i, Angle(i), CTot, fwhm, s(i), s(i)/smax*10000, s(i)/stot*100.0
   20 Continue
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine NewPrm(nMtx, IdxPek, IdxKnd, BMtx, Angle, Aniso,
     1              CGau, CLor, Gfwhm, rfwhm, Back, EPS, IsConv)
      Include 'PeakFit.prm'
      Integer nMtx, IdxPek(*), IdxKnd(*)
      Real*8 BMtx(*)
      Real Angle(*), Aniso(*), CGau(*), CLor(*), Gfwhm(*), rfwhm(*)
      Real Back(*)
      Real EPS
      Integer IsConv
      
      Integer i, ik, ip
      Real Val, Old, New
            
      Write(6, '(a)') ' *** New Parameters ***'
      Write(11, '(a)') ' *** New Parameters ***'
      IsConv = 1
      Do 10 i=1, nMtx
        ik = IdxKnd(i)
        ip = IdxPek(i)
        If(ip .eq. 0) Then
          Write(6, '(2x, i3, 3g14.6)')
     1          i, Back(ik), BMtx(i), Back(ik)+BMtx(i)
          Write(11, '(2x, i3, 3g14.6)')
     1          i, Back(ik), BMtx(i), Back(ik)+BMtx(i)
          Back(ik) = Back(ik) + BMtx(i)
          Val = Back(ik)
        Else If(ik .eq. 6) Then
c       Diff. with respect to CG
          Write(6, '(2x, i3, 3g14.6)')
     1          i, CGau(ip), BMtx(i), CGau(ip)+BMtx(i)
          Write(11, '(2x, i3, 3g14.6)')
     1          i, CGau(ip), BMtx(i), CGau(ip)+BMtx(i)
          CGau(ip) = CGau(ip) + BMtx(i)
          Val = CGau(ip)
        Else If(ik .eq. 7) Then
c       Diff. with respect to CL
          Write(6, '(2x, i3, 3g14.6)')
     1          i, CLor(ip), BMtx(i), CLor(ip)+BMtx(i)
          Write(11, '(2x, i3, 3g14.6)')
     1          i, CLor(ip), BMtx(i), CLor(ip)+BMtx(i)
          CLor(ip) = CLor(ip) + BMtx(i)
          Val = CLor(ip)
        Else If(ik .eq. 8) Then    
c       Diff. with respect to Qp
          Write(6, '(2x, i3, 3g14.6)')
     1          i, Angle(ip), BMtx(i), Angle(ip)+BMtx(i)
          Write(11, '(2x, i3, 3g14.6)')
     1          i, Angle(ip), BMtx(i), Angle(ip)+BMtx(i)
          Angle(ip) = Angle(ip) + BMtx(i)
          Val = Angle(ip)
c       Diff. with respect to Ap
        Else If(ik .eq. 9) Then
          Write(6, '(2x, i3, 3g14.6)')
     1          i, Aniso(ip), BMtx(i), Aniso(ip)+BMtx(i)
          Write(11, '(2x, i3, 3g14.6)')
     1          i, Aniso(ip), BMtx(i), Aniso(ip)+BMtx(i)
          Aniso(ip) = Aniso(ip) + BMtx(i)
          Val = Aniso(ip)
        Else If(ik .eq. 10) Then
c       Diff. with respect to 1/HG
          Write(6, '(2x, i3, 3g14.6)')
     1          i, 1.0/Gfwhm(ip), 1.0/(Gfwhm(ip)+BMtx(i))-1.0/Gfwhm(ip), 
     2          1.0/(Gfwhm(ip)+BMtx(i))
          Write(11, '(2x, i3, 3g14.6)')
     1          i, 1.0/Gfwhm(ip), 1.0/(Gfwhm(ip)+BMtx(i))-1.0/Gfwhm(ip), 
     2          1.0/(Gfwhm(ip)+BMtx(i))
          Gfwhm(ip) = Gfwhm(ip) + BMtx(i)
          Val = Gfwhm(ip)
        Else If(ik .eq. 11) Then
c       Diff. with respect to HG/HL
          Old = rfwhm(ip) * rfwhm(ip)
          Val = Old
          New = Old + Bmtx(i)
          Old = sqrt(Old)
          New = sqrt(New)
          Write(6, '(2x, i3, 3g14.6)')
     1          i, Old, New-Old, New
          Write(11, '(2x, i3, 3g14.6)')
     1          i, Old, New-Old, New
          rfwhm(ip) = New
        EndIf
        If(Val .eq. 0) Then
          If(Abs(BMtx(i)) .gt. EPS) IsConv = 0
        Else
          If(Abs(BMtx(i)) .gt. Abs(EPS*Val)) IsConv = 0
        EndIf
   10 Continue     
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine Marq(nMtx, AMtx, BMtx, Dump)
      Include 'PeakFit.prm'
      Integer nMtx
      Real*8 AMtx(MMtx, MMtx), BMtx(*)
      Real Dump
      
      Integer i, j
      Real*8 MaxA, EPS, WK(MMtx)
      Integer IER, IP(MMtx)
      
      EPS = 3.52E-15
      Do 10 i=1, nMtx
        MaxA = Abs(AMtx(i,i))
        If(MaxA .lt. 1.0e-30) MaxA = 1.0
        Do 30 j=1, nMtx
          AMtx(i,j) = AMtx(i,j) / MaxA
   30   Continue
        BMtx(i) = BMtx(i) / MaxA
   10 Continue
      Do 40 i=1, nMtx
        AMtx(i,i) = AMtx(i,i) + Dump
        BMtx(i) = -BMtx(i)
   40 Continue
      Call GLU(AMtx, nMtx, MMtx, BMtx, EPS, WK, IP, IER)
      If(IER .ne. 0) Then
        Write(6, '(a, i5)') ' ***** Error occured in GLU. IER=', IER 
        Write(11, '(a, i5)') ' ***** Error occured in GLU. IER=', IER 
        Stop 9999
      EndIf  
      
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine OldPrm(nPeak, Angle, Aniso, CGau, CLor,
     1              Gfwhm, rfwhm, PAngle, PAniso, PCGau, PCLor,
     2              PGfwhm, Prfwhm, nBack, Back, PBack)
      Include 'PeakFit.prm'
      Integer nPeak, nBack
      Real Angle(*), Aniso(*), CGau(*), CLor(*), Gfwhm(*), rfwhm(*)
      Real PAngle(*), PAniso(*), PCGau(*), PCLor(*), PGfwhm(*)
      Real Prfwhm(*), Back(*), PBack(*)
      
      Integer i
      
      Do 10 i=1, nPeak
        PAngle(i) = Angle(i)
        PCGau(i) = CGau(i)
        PCLor(i) = CLor(i)
        PGfwhm(i) = Gfwhm(i)
        Prfwhm(i) = rfwhm(i)
        PAniso(i) = Aniso(i)
   10 Continue
      Do 20 i=1, nBack
        PBack(i) = Back(i)
   20 Continue
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine InvDat(nPeak, Gfwhm, Lfwhm, rfwhm, CGau, CLor,
     1     GFrac, Height, Aniso)
      Include 'PeakFit.prm'
      Integer nPeak
      Real Gfwhm(*), Lfwhm(*), rfwhm(*), CGau(*), CLor(*), GFrac(*)
      Real Height(*), Aniso(*)
      
      Integer i
      
      Do 10 i=1, nPeak
        If(Gfwhm(i) .le. 0.0) Then
          Write(6,*)
          Write(11,*)
          Write(6,'(a,i5,g14.6)')
     1         '   Gaussian fwhm must be positive. #:',i,Gfwhm(i)
          Write(11,'(a,i5,g14.6)')
     1         '   Gaussian fwhm must be positive. #:',i,Gfwhm(i)
          Gfwhm(i) = 1000.0
        EndIf  
        Gfwhm(i) = 1.0 / Gfwhm(i)
        If(rfwhm(i) .le. 0.0) Then
          Write(6,*)
          Write(11,*)
          Write(6,'(a,i5,g14.6)')
     1         '   rfwhm must be positive. #:',i,rfwhm(i)
          Write(11,'(a,i5,g14.6)')
     1         '   rfwhm must be positive. #:',i,rfwhm(i)
          rfwhm(i) = 0.0001
        EndIf  
        Lfwhm(i) = Gfwhm(i) / rfwhm(i)
        If(CGau(i) .lt. 0.0) Then
          Write(6,*)
          Write(11,'(a,i5,g14.6)')
     1         '   C(Gauss) must be positive. #:',i,CGau(i)
          Write(6,*)
          Write(11,'(a,i5,g14.6)')
     1         '   C(Gauss) must be positive. #:',i,CGau(i)
          CGau(i) = 0.0
        EndIf  
        If(CLor(i) .lt. 0.0) Then
          Write(6,*)
          Write(11,'(a,i5,g14.6)')
     1         '   C(Lorentz) must be positive. #:',i,CLor(i)
          Write(6,*)
          Write(11,'(a,i5,g14.6)')
     1         '   C(Lorentz) must be positive. #:',i,CLor(i)
          CLor(i) = 0.0
        EndIf  
        Height(i) = CGau(i) + CLor(i)
        GFrac(i) = 1.0
        If(Height(i) .gt. 0.0) GFrac(i) = CGau(i) / Height(i)
        If(Aniso(i) .lt. 0.0) Then
          Write(6,*)
          Write(11,'(a,i5,g14.6)')
     1        '   Anisotropic parameter must be positive. #:',i,Aniso(i)
          Write(6,*)
          Write(11,'(a,i5,g14.6)')
     1        '   Anisotropic parameter must be positive. #:',i,Aniso(i)
          Aniso(i) = 0.0
        EndIf  
        
   10 Continue
      End    
c**********************************************************************
c
c**********************************************************************
      Subroutine Diff(nMtx, AMtx, BMtx, IdxPek, IdxKnd,
     1          nData, XVal, YErr, nPeak, CGau, CLor,
     2          Angle, Aniso, Gfwhm, rfwhm,
     3          QRange, nBack)
      Include 'PeakFit.prm'
      Integer nMtx, nData, nPeak, nBack
      Integer IdxPek(*), IdxKnd(*)
      Real*8 BMtx(*), AMtx(MMtx, MMtx)
      Real XVal(*), YErr(*)
      Real CGau(*), CLor(*), Angle(*), Aniso(*), Gfwhm(*), rfwhm(*)
      Real QRange

      Integer i, j, ip, ib, jb, id, jp, ik, jk, ia, ja
      Real Qmin(MPeak), Qmax(MPeak)
      Real xpow(0:MBack), coeLp(MPeak)
      Real Q, Gf, rf, Lf, err, fXX
      
      Real Q1i, Gfi, coeLi, Qmini, Qmaxi
      Real fl1i, fg1i, fX1i, CGi, CLi, dQ1i
      Real xx1i
      Real fCGi, fCLi, fXi, fQi, fAi, fHi, XQi, XA1i, fRi
      Real XH1i, fR1i
      Real Q1j, Gfj, coeLj, Qminj, Qmaxj
      Real fl1j, fg1j, fX1j, CGj, CLj, dQ1j
      Real fCGj, fCLj, fXj, fQj, fAj, fHj, XQj, XA1j, fRj
      Real XH1j, fR1j
      
      Real fDifi(11), fDifj(11)
      Real coeG
      Data coeG/2.772588722/

      Do 10 i=1, nMtx
        BMtx(i) = 0.0
        Do 20 j=1, i
          AMtx(i,j) = 0.0
   20   Continue       
   10 Continue
      Do 30 ip=1, nPeak
        Q1 = Angle(ip)
        Gf = 1.0/Gfwhm(ip)
        rf = rfwhm(ip)
        Lf = Gf / rf
        If(Gf .ge. Lf) Then
          qw = Gf * QRange
        Else
          qw = Lf * QRange
        EndIf
        Gf = Gfwhm(ip)
        coeL = rf * rf * 4.0
        Qmin(ip) = Q1-qw
        Qmax(ip) = Q1+qw
        coeLp(ip) = rfwhm(ip) * rfwhm(ip) * 4.0 
   30 Continue
   
      Do 100 id=1, nData
        Q = XVal(id)
        xpow(0) = 1.0
        Do 105 ib=1, nBack-1
          xpow(ib) = Q * xpow(ib-1)
c          write(6, '(a,g14.6)') ' xpow=',xpow(ib)
  105   Continue    
        Err = YErr(id)

        Do 110 i=1, nMtx
          ik = IdxKnd(i)
          ip = IdxPek(i)
          If(ip .eq. 0) Then
            ib = ik-1
            BMtx(i) = BMtx(i) - Err*xpow(ib)
          Else
            Qmini  = Qmin(ip)
            Qmaxi  = Qmax(ip)
            If((Q .lt. Qmini) .or. (Q .gt. Qmaxi)) GoTo 110
            Q1i    = Angle(ip)
            Gfi    = Gfwhm(ip)
            coeLi  = coeLp(ip)
            CGi    = CGau(ip)
            CLi    = CLor(ip)
            dQ1i = Q - Q1i
            xx1i = dQ1i * Gfi
            fg1i = exp(-coeG*xx1i*xx1i)
            fl1i = 1.0 / (1.0 + coeLi*xx1i*xx1i)
            fX1i = -2.0*xx1i*(CGi*coeG*fg1i + CLi*coeLi*fl1i*fl1i)
            XQi  = -Gfi
            XA1i = Gfi
            XH1i = dQ1i
            fXX1 = -2.0*(CGi*coeG*fg1i + CLi*coeL*fl1i*fl1i)
     1           + 4.0 * xx1i*xx1i * (CGi*coeG*coeG*fg1i
     2                             + 2.0*CLi*coeL*coeL*fl1i*fl1i*fl1i)
            fR1i = -CLi * 4.0 * xx1i*xx1i * fl1i*fl1i
            fCGi = fg1i
            fCLi = fl1i
            fXi  = fX1i
            fQi  = fX1i
            fAi  = fX1i*XA1i
            fHi  = fX1i*XH1i
            fXX  = fXX1
            fRi  = fR1i
            fDifi(1) = xpow(0)
            fDifi(2) = xpow(1)
            fDifi(3) = xpow(2)
            fDifi(4) = xpow(3)
            fDifi(5) = xpow(4)
c       Diff. with respect to CG
            fDifi(6) = fCGi
c       Diff. with respect to CL
            fDifi(7) = fCLi
c       Diff. with respect to Qp
            fDifi(8) = fQi
c       Diff. with respect to Ap
            fDifi(9) = fAi
c       Diff. with respect to 1/HG
            fDifi(10) = fHi
c       Diff. with respect to HG/HL
            fDifi(11) = fRi

            BMtx(i) = BMtx(i) - Err*fDifi(ik)
          EndIf
          
          Do 120 j=1, i
            jk = IdxKnd(j)
            jp = IdxPek(j)
            jb = jk-1
            If(jp .eq. 0) Then
              AMtx(i,j) = AMtx(i,j) + xpow(jb) * fDifi(ik)
            Else  
              Qminj  = Qmin(jp)
              Qmaxj  = Qmax(jp)
              If((Q .lt. Qminj) .or. (Q .gt. Qmaxj)) GoTo 120
              Q1j    = Angle(jp)
              Gfj    = Gfwhm(jp)
              coeLj  = coeLp(jp)
              CGj    = CGau(jp)
              CLj    = CLor(jp)
              dQ1j = Q - Q1j
              xx1j = dQ1j * Gfj
              fg1j = exp(-coeG*xx1j*xx1j)
              fl1j = 1.0 / (1.0 + coeLj*xx1j*xx1j)
              fX1j = -2.0*xx1j*(CGj*coeG*fg1j + CLj*coeLj*fl1j*fl1j)
              XQj  = -Gfj
              XA1j = Gfj
              XH1j = dQ1j
              fR1j = -CLj * 4.0 * xx1j*xx1j * fl1j*fl1j  
              fCGj = fg1j
              fCLj = fl1j
              fXj  = fX1j
              fQj  = fX1j*XQj
              fAj  = fX1j*XA1j
              fHj  = fX1j*XH1j
              fRj  = fR1j

              fDifj(1) = xpow(0)
              fDifj(2) = xpow(1)
              fDifj(3) = xpow(2)
              fDifj(4) = xpow(3)
              fDifj(5) = xpow(4)
c       Diff. with respect to CG
              fDifj(6) = fCGj
c       Diff. with respect to CL
              fDifj(7) = fCLj
c       Diff. with respect to Qp
              fDifj(8) = fQj
c       Diff. with respect to Ap
              fDifj(9) = fAj
c       Diff. with respect to 1/HG
              fDifj(10) = fHj
c       Diff. with respect to HG/HL
              fDifj(11) = fRj
c       Diff. with respect to CG
              AMtx(i,j) = AMtx(i,j) + fDifj(jk) * fDifi(ik)

              If(ip .eq. jp) Then
c       Diff. with respect to Qp
                If(ik .eq. 8) Then
c                  AMtx(i,j) = AMtx(i,j) - Err*fQi
c       Diff. with respect to Ap
                Else If(ik .eq. 9) Then
c                  AMtx(i,j) = AMtx(i,j) - Err*fAi
c       Diff. with respect to 1/HG
                Else If(ik .eq. 10) Then
c                  AMtx(i,j) = AMtx(i,j) - Err*fHi
c       Diff. with respect to HG/HL
                Else If(ik .eq. 11) Then
                EndIf
              EndIf
            EndIf
  120     Continue          
  110   Continue    
  100 Continue

      Do 1000 i=1, nMtx
        Do 1010 j=1, i-1
          AMtx(j,i) = AMtx(i,j)
 1010   Continue
 1000 Continue         
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine BasPrf(nData, XVal, YVal, YCal, BG, YErr, 
     1       nPeak, CGau, CLor, Angle, Aniso, Gfwhm, rfwhm, nBack, Back,
     2       QRange, Sigma, PSigma)
      Include 'PeakFit.prm'
      Integer nData, nBack, nPeak
      Real XVal(*), YVal(*), YCal(*), BG(*), YErr(*)
      Real CGau(*), CLor(*), Angle(*), Aniso(*), Gfwhm(*), rfwhm(*)
      Real Back(*)
      Real QRange, Sigma, PSigma
      Real coeG
      Data coeG/2.772588722/
      
      Integer i, j, ip, ia
      Real YCal1(MPeak, MData)
      Real Val, xn, Q, Q1, dQ, Qmin, Qmax, d, Gf, Lf, qw
      Real xx1a, f1, fa, fb, rf, aa, ab
      Real coeL, fCG, fCL
      Real Avrg
      
      Do 10 i=1, nData
        BG(i) = 0.0
        Q = XVal(i)
        Val = Back(1)
        xn = 1
        Do 20 j=2, nBack
          xn = xn * Q
          Val = Val + Back(j) * xn
   20   Continue
        BG(i) = Val
   10 Continue
      Do 40 ip=1, nPeak
        Q1 = Angle(ip)
        Gf = 1.0/Gfwhm(ip)
        rf = rfwhm(ip)
        Lf = Gf / rf
        If(Gf .ge. Lf) Then
          qw = Gf * QRange
        Else
          qw = Lf * QRange
        EndIf
        Gf = Gfwhm(ip)
        coeL = rf * rf * 4.0
        Qmin = Q1-qw
        Qmax = Q1+qw
        Do 50 i=1, nData
          Q = XVal(i)
          If(Q .lt. Qmin) GoTo 50
          If(Q .gt. Qmax) GoTo 50
          dQ = Q-Q1
          xx1a = dQ * Gf
          fa = exp(-coeG*xx1a*xx1a)
          fb = 1.0 / (1.0 + coeL*xx1a*xx1a)
          fCG = fa
          fCL = fb
          YCal1(ip, i) = CGau(ip)* fCG + CLor(ip) * fCL
   50   Continue
   40 Continue
      Sigma = 0.0
      Avrg = 0.0
      Do 100 i=1, nData
        YCal(i) = BG(i)
        Do 110 ip=1, nPeak
          YCal(i) = YCal(i) + YCal1(ip,i)
  110   Continue
        Avrg = Avrg + YVal(i)
        YErr(i) = YVal(i) - YCal(i)
        Sigma = Sigma + YErr(i) * YErr(i)
  100 Continue
      Avrg = Avrg/nData
      PSigma = sqrt(abs(Sigma/(nData-1)))/Avrg * 100.0
c      write(6,*) sigma, ndata, avrg, psigma
c      PSigma = 0.0
      Return
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine MkIdx(nPeak, Angle, idBack, idAng, idHei, idGFra,
     1           idGfwh, idrfwh, idAnis, OptX0, OptX1, nMtx,
     2           IdxPek, IdxKnd)
      Include 'PeakFit.prm'
      Integer nPeak, nMtx
      Real Angle(*)
      Integer idBack(*), idAng(*), idHei(*), idGFra(*), idGfwh(*)
      Integer idrfwh(*), idAnis(*)
      Integer IdxPek(*), IdxKnd(*)
      Real OptX0, OptX1
      
      Integer i
      Real Ang(MMtx)

      Write(6, '(a, 2g14.6)')
     1     ' ***Make index for optimization in range of ', OptX0, OptX1
      Write(11, '(a, 2g14.6)')
     1     ' ***Make index for optimization in range of ', OptX0, OptX1
c IdxKnd = 1 - 5   : Back ground parameters
c          6: C(Gauss)      7: C(Lorentz)     8: Q      9: A
c         10: fwhm(Gauss)  11: fwhm(Gauss)/fwhm(Lorentz)
      nMtx = 0
      Do 10 i=1, 5
        If(idBack(i) .ne. 1) GoTo 10
        nMtx = nMtx+1
        IdxKnd(nMtx) = i
        IdxPek(nMtx) = 0
   10 Continue
      Do 20 i=1, nPeak
        If((Angle(i) .lt. OptX0) .or. (Angle(i) .gt. OptX1)) GoTo 20
        If(idHei(i) .eq. 1) Then
          nMtx = nMtx+1
          If(nMtx .gt. MMtx) Call JobEnd(' nMtx too large')
          IdxKnd(nMtx) = 6
          IdxPek(nMtx) = i
        EndIf  
        If(idGFra(i) .eq. 1) Then
          nMtx = nMtx+1
          If(nMtx .gt. MMtx) Call JobEnd(' nMtx too large')
          IdxKnd(nMtx) = 7
          IdxPek(nMtx) = i
        EndIf  
        If(idAng(i) .eq. 1) Then
          nMtx = nMtx+1
          If(nMtx .gt. MMtx) Call JobEnd(' nMtx too large')
          IdxKnd(nMtx) = 8
          IdxPek(nMtx) = i
        EndIf  
        If(idAnis(i) .eq. 1) Then
          nMtx = nMtx+1
          If(nMtx .gt. MMtx) Call JobEnd(' nMtx too large')
          IdxKnd(nMtx) = 9
          IdxPek(nMtx) = i
        EndIf  
        If(idGfwh(i) .eq. 1) Then
          nMtx = nMtx+1
          If(nMtx .gt. MMtx) Call JobEnd(' nMtx too large')
          IdxKnd(nMtx) = 10
          IdxPek(nMtx) = i
        EndIf  
c        idrfwh(i) = 0
        If(idrfwh(i) .eq. 1) Then
          nMtx = nMtx+1
          If(nMtx .gt. MMtx) Call JobEnd(' nMtx too large')
          IdxKnd(nMtx) = 11
          IdxPek(nMtx) = i
        EndIf  
   20 Continue
      Write(6, '(a, i5)')
     1       ' *** Number of parameters to be optimized: ', nMtx
      Write(11, '(a, i5)')
     1       ' *** Number of parameters to be optimized: ', nMtx
      Do 30 i=1, nMtx
        If(IdxPek(i) .gt. 0) Then
          Ang(i) = Angle(IdxPek(i))
        Else  
          Ang(i) = 0.0
        EndIf
   30 Continue
      Write(6, '(5(i4, i3, f8.3))') (IdxPek(i), IdxKnd(i), Ang(i),
     1          i=1, nMtx)
      Write(11, '(5(i4, i3, f8.3))') (IdxPek(i), IdxKnd(i), Ang(i),
     1          i=1, nMtx)
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine CnvDat(nOData, XOrg, YOrg, nData, XVal, YVal,
     1                  CalcX0, CalcX1, nPeak, Gfwhm,
     2                  CGau, CLor, Height, GFrac)
      Include 'PeakFit.prm'
      Integer nOData, nData, nPeak
      Real XOrg(*), YOrg(*), XVal(*), YVal(*), CalcX0, CalcX1
      Real Gfwhm(*), CGau(*), CLor(*), Height(*), GFrac(*)

      Integer i
      
      nData = 0
      Do 10 i=1, nOData
        If(XOrg(i) .lt. CalcX0) GoTo 10
        If(XOrg(i) .gt. CalcX1) GoTo 20
        nData = nData + 1
        If(nData .gt. MData) Call JobEnd(' nData too large')
        XVal(nData) = XOrg(i)
        YVal(nData) = YOrg(i)
   10 Continue
   20 Continue
      Write(6, '(a, i5)')
     1       ' *** Number of data used in the calculation: ', nData
      Write(11, '(a, i5)')
     1       ' *** Number of data used in the calculation: ', nData
      Do 30 i=1, nPeak
        Gfwhm(i) = 1.0/Gfwhm(i)  
        CGau(i) = Height(i) * GFrac(i)
        CLor(i) = Height(i) * (1.0-GFrac(i))
   30 Continue     
      Return
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine SvOld(nPeak, Angle, OAngle, Height, OHeigh, GFrac,
     1           OGFrac, Gfwhm, OGfwhm, Lfwhm, OLfwhm, rfwhm, Orfwhm,
     2           Aniso, OAniso, nBack, Back, OBack)
      Integer nPeak, nBack
      Real Angle(*), OAngle(*), Height(*), OHeigh(*), GFrac(*)
      Real OGFrac(*), Gfwhm(*), OGfwhm(*), Lfwhm(*), OLfwhm(*)
      Real rfwhm(*), Orfwhm(*), Aniso(*), OAniso(*), Back(*), OBack(*)
      
      Integer i
      
      Do 10 i=1, nPeak
        OAngle(i) = Angle(i)
        OHeigh(i) = Height(i)
        OGFrac(i) = GFrac(i)
        OGfwhm(i) = Gfwhm(i)
        OLfwhm(i) = Lfwhm(i)
        Orfwhm(i) = rfwhm(i)
        OAniso(i) = Aniso(i)
   10 Continue
      Do 20 i=1, nBack
        OBack(i) = Back(i)
   20 Continue        
      End     
