// RealDC.h: CRealDC NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_READDC_H__ECB1C19E_9580_11D1_84E9_485223000000__INCLUDED_)
#define AFX_READDC_H__ECB1C19E_9580_11D1_84E9_485223000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CRealPoint  
{
public:
	double x, y;

	CRealPoint(double x0 = 0, double y0 =0);
	virtual ~CRealPoint();
	virtual CRealPoint &operator=(CRealPoint pt)
	{
		x = pt.x;
		y = pt.y;
		return *this;
	};
};

class CRealRect  
{
public:
	double left, bottom, right, top;

	CRealRect(double x0 = 0, double y0 = 0, double x1 = 0, double y1 = 0);
	virtual ~CRealRect();
	CRealRect &SetNormalizedRect(double x0, double y0, double x1, double y1);
	virtual CRealRect &operator=(CRealRect &rt);
	virtual CRealRect &operator+=(CRealRect &rt);
//	virtual CRealRect &operator+(CRealRect &rt1, CRealRect &rt2);
};

class CRealDC : public CDC  
{
protected:
	int m_HorzSize, m_VertSize;
    int m_HorzRes, m_VertRes;
	int m_BitsPixel;
	double m_AspectX, m_AspectY;
	double m_mmPerPixelX, m_mmPerPixelY;
	double m_PixelPermmX, m_PixelPermmY;
	double m_CharPointPerPixelX, m_CharPointPerPixelY;
	double m_ViewMagnification, m_ViewCharMag;
	double m_OffsetX, m_OffsetY;
public:
	BOOL CreatePointFontIndirect(const LOGFONT *lpLogFont, CFont *font);
	int  CharSizePixelToPoint(LOGFONT *lpLogFont);
	int  CharSizePointToPixel(LOGFONT *lpLogFont);
	CString & GetDeviceInfoString();
	BOOL CreateFontIndirect(const LOGFONT *lpLogFont, CFont *font);
	CRealDC(CDC *pdc);
	virtual ~CRealDC();

	int SizeToPixelX(double x)
	{
		return (int)((x+m_OffsetX)*m_PixelPermmX*m_ViewMagnification+1e-5);
	};
	int SizeToPixelY(double y)
	{
		return (int)((y+m_OffsetY)*m_PixelPermmY*m_ViewMagnification+1e-5);
	};
	double PixelToSizeX(int x)
	{
		return (double)x*m_mmPerPixelX/m_ViewMagnification-m_OffsetX;
	};
	double PixelToSizeY(int y)
	{
		return (double)y*m_mmPerPixelY/m_ViewMagnification-m_OffsetY;
	};

	CRealRect &TextOut(double x, double y, CString str, double directionangle = 0.0);
	CPoint MoveTo(double x, double y);
	CPoint LineTo(double x, double y,
		int linestyle = PS_SOLID, double linewidth = 0.2, COLORREF linecolor = RGB(0,0,0));
	CRealRect &Line(double x0, double y0, double x1, double y1,
		int linestyle = PS_SOLID, double linewidth = 0.2, COLORREF linecolor = RGB(0,0,0));
	BOOL Ellipse(double x0, double y0, double x1, double y1,
		int linestyle = PS_SOLID, double linewidth = 0.2, COLORREF linecolor = RGB(0,0,0),
		int fillstyle = BS_NULL, COLORREF hatchcolor = RGB(0,0,0), int hatchstyle = HS_CROSS);
	BOOL Circle(double x0, double y0, double r,
		int linestyle = PS_SOLID, double linewidth = 0.2, COLORREF linecolor = RGB(0,0,0),
		int fillstyle = BS_NULL, COLORREF hatchcolor = RGB(0,0,0), int hatchstyle = HS_CROSS)
	{
		return Ellipse(x0-r, y0-r, x0+r, y0+r,
			linestyle, linewidth, linecolor,
			fillstyle, hatchcolor, hatchstyle);
	};
	CRealRect &Rectangle(double x0, double y0, double x1, double y1,
		int linestyle = PS_SOLID, double linewidth = 0.2, COLORREF linecolor = RGB(0,0,0),
		int fillstyle = BS_NULL, COLORREF hatchcolor = RGB(0,0,0), int hatchstyle = HS_CROSS);
	int GetIntWidth(double width);
	int GetTextExtent(CString str, double *w, double *h);
	int GetDeviceInfo();
};

#endif // !defined(AFX_READDC_H__ECB1C19E_9580_11D1_84E9_485223000000__INCLUDED_)
